var IRC = require('irc');

exports.connect = function () {
    var args = Array.prototype.slice.call(arguments);
    var cb = args.pop();

    switch (args.length) {
        case 0:
            args[0] = 'irc.freenode.net';
        case 1:
            args[1] = 'ircrpcbot'
        case 2:
            break
        default:
            args = args.slice(0,2);
            break
    }
    
    var client = new IRC.Client(args[0], args[1]);
    client.on('motd', function () {
        cb({
            addService: function(conn) {
                //conn.nick: service nick
                //conn.stringify: input --> request
                //conn.parse: output --> callbacked stuff
                //conn.take: How many lines to take

                conn.stringify = args.stringify || stringifyers.basic;

                conn.parse = args.parse || parsers.basic;

                conn.take = args.take || takers.oneLine;

                return function() {
                    //say the stringified request
                    var args = Array.prototype.slice.call(arguments);
                    var cb = args.pop();

                    var msgCollect = [];

                    client.say(conn.nick, conn.stringify(args));

                    client.on('pm', function listener (from, msg) {
                        if (from === conn.nick) {
                            msgCollect.push(msg);
                        }
                        if (conn.take(msgCollect)) {
                            //This is where the callback happens!
                            cb(conn.parse(msgCollect));
                            client.removeListener('pm', listener);
                        }
                        
                    });
                    
                };
            },
            disconnect: function () { client.disconnect(); }
        });
    });
}

var parsers = exports.parsers = 
    { basic: function(array) {
                 return array.join('\n').trim();
             }
    };

var stringifyers = exports.stringifyers = 
    { basic: function (array) {
                 return array.join(' ');
             }
    };

var takers = exports.takers =
    { oneLine: function (lines) {
                   return lines.length > 0;
               }
    };
